Option Explicit
'AREA_PENTIS
' This game concept and VB source code Copyright (c) 1995 Robin Upton
' If you wish to use any part of it, you can get in touch
' with me at     http://www.csv.warwick.ac.uk/~edpgn/



'Gameplay
Global Const Score_per_line% = 15
Global Const Time_Const = 15 ' = 5 seconds per piece

'Program details
Global Const HISCORE_FILE$ = ".\scores.hi"
Global Const INI_FILE$ = "c:\windows\area_pt.ini"
Global Const Max_No_Pieces% = 82
Global Const Max_No_High_Scores% = 13

'Cosmetic Constants
Global Const No_times_to_flash% = 5
Global Const TopBorderWidth% = 300
Global Const OtherBorderWidths% = 220

'Defaults
Global Const Default_Difficulty = 1
Global Const Default_Height% = 8100
Global Const Default_Width% = 8100
Global Const Default_x% = 500
Global Const Default_y% = 8700
Global Const Default_Grid_Size% = 8
Global Const Default_Timed% = 0
Global Const Default_NextPiece% = 1
Global Const Default_Pieces% = 5
Global Const Default_ColourOn% = True
Global Const Default_Sound% = True
Global Const Default_Highlight% = True

'Global Variables
Global The_Grid As Griid    'This is the Grid, only that word is a reserved word :(
Global The_Piece As piece   'This is the piece we put down
Global The_Cursor As coords
Global Next_Piece_Grid As Griid
Global Cheatcode%
Global Cheated%

'This is where the piece is relative to the origin
Global The_Difficulty%
Global GSize%
Global Piece_Set%
Global The_Score%
Global No_Rows%
Global No_Columns%
Global No_Pieces%
Global Next_piece_no%
Global ColourOn%
Global Sound%
Global HighlightPiece%

Global The_Pieces(1 To Max_No_Pieces) As piece
Global Difficulty_String$
Global High_Score%(2, 3, 4, 1 To Max_No_High_Scores)
Global High_Pieces%(2, 3, 4, 1 To Max_No_High_Scores)
Global High_Cols%(2, 3, 4, 1 To Max_No_High_Scores)
Global High_Rows%(2, 3, 4, 1 To Max_No_High_Scores)
Global High_Name$(2, 3, 4, 1 To Max_No_High_Scores)

Global Difficulty_Name$(4)
Global Pieces_Name$(3)
Global Was_minimised%
Global Was_paused%
Global Timed%
Global High_Score_Number%
Global No_Time_Units_To_Drop%

Sub initialise_piece (pieceno%, s%, v%, xrs%, yrs%, c&, x1%, y1%, x2%, y2%, x3%, y3%, x4%, y4%, x5%, y5%, x6%, y6%)
    The_Pieces(pieceno).size = s
    The_Pieces(pieceno).value = v
    The_Pieces(pieceno).xrotshift = xrs
    The_Pieces(pieceno).yrotshift = yrs
    The_Pieces(pieceno).colour = c
    The_Pieces(pieceno).cells(1).x = x1
    The_Pieces(pieceno).cells(1).y = y1
    The_Pieces(pieceno).cells(2).x = x2
    The_Pieces(pieceno).cells(2).y = y2
    The_Pieces(pieceno).cells(3).x = x3
    The_Pieces(pieceno).cells(3).y = y3
    The_Pieces(pieceno).cells(4).x = x4
    The_Pieces(pieceno).cells(4).y = y4
    The_Pieces(pieceno).cells(5).x = x5
    The_Pieces(pieceno).cells(5).y = y5
    The_Pieces(pieceno).cells(6).x = x6
    The_Pieces(pieceno).cells(6).y = y6
End Sub

Sub initialise_piece_set ()
    'Initialise_piece(pieceno, size,value,xrotshift, yrotshift, colour,x1,y1 .. x6,y6)
    'Tetris pieces
    Call initialise_piece(1, 4, 2, 0, 0, RGB(230, 120, 120), -1, 0, 0, 0, 1, 0, 2, 0, 99, 99, 99, 99)'thin piece
    Call initialise_piece(2, 4, 2, 0, 0, RGB(230, 225, 50), 0, 0, 0, 1, 1, 1, 1, 0, 99, 99, 99, 99)'square piece
    Call initialise_piece(3, 4, 3, 0, 0, RGB(35, 25, 255), -1, 1, -1, 0, 0, 0, 0, -1, 99, 99, 99, 99) 'jagged piece
    Call initialise_piece(4, 4, 3, 0, 0, RGB(195, 0, 255), 1, 1, 1, 0, 0, 0, 0, -1, 99, 99, 99, 99) 'reverse jagged piece
    Call initialise_piece(5, 4, 2, 0, 0, RGB(125, 90, 185), 1, 0, 0, 0, -1, 0, 0, 1, 99, 99, 99, 99)'t-shaped piece
    Call initialise_piece(6, 4, 2, 0, 0, RGB(0, 255, 0), -1, 0, 0, 0, 1, 0, 1, 1, 99, 99, 99, 99)'reverse L-shaped piece
    Call initialise_piece(7, 4, 2, 0, 0, RGB(15, 165, 85), -1, 0, 0, 0, 1, 0, 1, -1, 99, 99, 99, 99)'L-shaped piece
    'Pentis Pieces
    Call initialise_piece(8, 5, 4, 0, 0, RGB(120, 140, 0), -1, 1, -1, 0, 0, 0, 1, 0, 1, -1, 99, 99)'reverse zigzag-shaped piece
    Call initialise_piece(9, 5, 6, 0, 0, RGB(220, 40, 160), -1, 1, -1, 0, 0, 0, 0, -1, 1, -1, 99, 99)'W-shaped piece
    Call initialise_piece(10, 5, 5, 0, 0, RGB(200, 40, 30), -1, 0, 0, 0, 1, 0, 0, 1, 0, -1, 99, 99)'+-shaped piece
    Call initialise_piece(11, 5, 5, 0, 0, RGB(255, 0, 0), -2, -1, -1, -1, 0, -1, 0, 0, 1, 0, 99, 99)'___=- -shaped piece
    Call initialise_piece(12, 5, 5, 0, 0, RGB(255, 140, 60), -2, 0, -1, 0, 0, 0, 0, -1, 1, -1, 99, 99)'--=_ -shaped piece
    Call initialise_piece(13, 5, 4, 0, 0, RGB(255, 40, 60), -1, 0, 0, 0, 1, 0, 1, 1, 0, -1, 99, 99)'-=" -shaped piece
    Call initialise_piece(14, 5, 4, 0, 0, RGB(10, 240, 140), -1, 0, 0, 0, 1, 0, 1, -1, 0, 1, 99, 99)'-=" -shaped piece
    Call initialise_piece(15, 5, 3, 0, 0, RGB(0, 95, 205), -1, 0, 0, 0, 1, 0, 1, -1, 1, 1, 99, 99)'T-shaped piece
    Call initialise_piece(16, 5, 3, 0, 0, RGB(50, 200, 200), -1, -1, -1, 0, -1, 1, 0, 1, 1, 1, 99, 99)'L-shaped piece
    Call initialise_piece(17, 5, 3, 0, 0, RGB(0, 140, 60), -2, 0, -1, 0, 0, 0, 1, 0, 2, 0, 99, 99)'Long thin piece
    Call initialise_piece(18, 5, 3, 0, 0, RGB(195, 255, 0), -2, 0, -1, 0, 0, 0, 1, 0, 1, 1, 99, 99)'L-shaped piece
    Call initialise_piece(19, 5, 3, 0, 0, RGB(20, 40, 160), -2, 0, -1, 0, 0, 0, 1, 0, 1, -1, 99, 99)'reverse L-shaped piece
    Call initialise_piece(20, 5, 3, 0, 0, RGB(20, 120, 250), -1, 1, -1, 0, 0, 0, 1, 0, 1, 1, 99, 99)'U-shaped piece
    Call initialise_piece(21, 5, 3, 0, 0, RGB(0, 0, 255), -1, 1, 0, 1, -1, 0, 0, 0, 1, 0, 99, 99)'P-shaped piece
    Call initialise_piece(22, 5, 3, 0, 0, RGB(75, 225, 0), -1, 1, 0, 1, -1, 0, 0, 0, 1, 1, 99, 99)'reverse P-shaped piece
    Call initialise_piece(23, 5, 4, 0, 0, RGB(120, 60, 200), -1, -1, -1, 0, 0, 0, 1, 0, 1, 1, 99, 99)'zigzag-shaped piece
    'Sextis Pieces
    Call initialise_piece(24, 6, 7, 0, 0, RGB(30, 80, 120), -2, 0, -1, 0, 0, 0, 1, 0, 2, 0, 3, 0)'thin piece
    Call initialise_piece(25, 6, 6, 0, 0, RGB(200, 100, 200), -2, 0, -1, 0, 0, 0, 1, 0, 2, 0, 2, 1)'L-shaped piece
    Call initialise_piece(26, 6, 6, 0, 0, RGB(100, 200, 200), -2, 0, -1, 0, 0, 0, 1, 0, 2, 0, 2, -1)'reverse L-shaped piece
    Call initialise_piece(27, 6, 4, 0, 0, RGB(0, 140, 0), -1, -1, -1, 0, 0, -1, 0, 0, 1, 0, 1, -1)  'rectangular piece
    Call initialise_piece(28, 6, 5, 0, 0, RGB(155, 35, 175), -1, -1, -1, 0, 0, 0, -1, 1, 0, -1, 1, -1)'triangular piece
    Call initialise_piece(29, 6, 7, 0, 0, RGB(120, 70, 90), -1, -1, -1, 0, 0, -1, 0, 1, -1, 1, 1, 1)'u-shaped piece
    Call initialise_piece(30, 6, 7, 0, 0, RGB(80, 90, 40), -1, -1, -1, 0, 0, -1, 0, 1, -1, 1, 1, -1)'reverse u-shaped piece
    Call initialise_piece(31, 6, 9, 0, 0, RGB(0, 50, 100), -1, -1, -1, 0, 0, 0, 0, -1, 1, 0, 0, 1)'rabbity-6-shaped piece
    Call initialise_piece(32, 6, 8, 0, 0, RGB(10, 220, 100), 1, -1, -1, 0, 0, 0, 1, 0, 1, 1, -1, 1)'h-shaped piece
    Call initialise_piece(33, 6, 8, 0, 0, RGB(200, 10, 100), -1, -1, -1, 0, 0, 0, 1, 0, 1, 1, -1, 1)'reverse h-shaped piece
    Call initialise_piece(34, 6, 9, 0, 0, RGB(135, 180, 60), -1, -1, -1, 0, 0, 0, 1, 0, -1, 1, 0, -1)'clumpy6-shaped piece
    Call initialise_piece(35, 6, 9, 0, 0, RGB(220, 220, 95), -1, -1, -1, 0, 0, 0, 0, 1, 1, -1, 0, -1)'reverse-clumpy6-shaped piece
    Call initialise_piece(36, 6, 7, 0, 0, RGB(180, 195, 160), -1, 1, -1, 0, 0, 0, 1, 0, 1, 1, 0, -1)'v-shaped piece
    Call initialise_piece(37, 6, 6, 0, 0, RGB(130, 0, 110), -1, -1, -1, 0, 0, 0, 1, 0, 2, 0, 2, -1)'receiver-shaped piece
    Call initialise_piece(38, 6, 8, 0, 0, RGB(80, 240, 80), -1, -1, -1, 0, 0, 0, 0, 1, 1, 1, 1, 2)'zigzag-shaped piece
    Call initialise_piece(39, 6, 6, 0, 0, RGB(60, 90, 0), -1, -1, -1, 0, 0, 0, 1, 0, 1, 1, 0, -1) 'square+2-shaped piece
    Call initialise_piece(40, 6, 6, 0, 0, RGB(140, 0, 140), -1, -1, -1, 0, 0, 0, 0, 1, 1, 1, 0, -1) 'reverse square+2-shaped piece
    Call initialise_piece(41, 6, 10, 0, 0, RGB(0, 140, 225), -1, -1, -1, 0, 0, 0, 1, 0, 2, 0, 2, 1)'wide z-shaped piece
    Call initialise_piece(42, 6, 10, 0, 0, RGB(125, 225, 120), -1, 1, -1, 0, 0, 0, 1, 0, 2, 0, 2, -1)'reverse wide z-shaped piece
    Call initialise_piece(43, 6, 6, 0, 0, RGB(210, 90, 0), -1, -1, -1, 0, -1, 1, 0, 0, 1, 0, 2, 0)'Tall t-shaped piece
    Call initialise_piece(44, 6, 8, 0, 0, RGB(45, 0, 210), -1, 0, 1, 0, 0, 0, 0, 1, 0, -1, 2, 0)'cross-shaped piece
    Call initialise_piece(45, 6, 8, 0, 0, RGB(170, 120, 40), -2, 0, -1, 0, 0, 0, 0, -1, 1, 0, 2, 0)'short t-shaped piece
    Call initialise_piece(46, 6, 7, 0, 0, RGB(140, 90, 255), -2, 0, -1, 0, 0, 0, 1, -1, 1, 0, 2, 0)'flat+1-shaped piece
    Call initialise_piece(47, 6, 7, 0, 0, RGB(190, 40, 235), -2, 0, -1, 0, 0, 0, -1, -1, 1, 0, 2, 0)'reverse flat+1-shaped piece
    Call initialise_piece(48, 6, 7, 0, 0, RGB(30, 10, 130), -1, -1, -1, 0, 0, -1, 1, 0, 1, -1, 2, 0)'reverse ?-shaped piece
    Call initialise_piece(49, 6, 7, 0, 0, RGB(130, 10, 30), -1, -1, -1, 0, 0, -1, 1, 0, 1, -1, -2, 0)'?-shaped piece
    Call initialise_piece(50, 6, 5, 0, 0, RGB(208, 80, 100), -1, -1, -1, 0, 0, 0, 1, 0, 2, 0, 0, -1)'=__ -shaped piece
    Call initialise_piece(51, 6, 5, 0, 0, RGB(200, 110, 75), -1, 1, -1, 0, 0, 0, 1, 0, 2, 0, 0, 1)'reverse =__ -shaped piece
    Call initialise_piece(52, 6, 6, 0, 0, RGB(70, 180, 150), -1, 0, 0, 0, 1, 0, 2, 0, 1, 1, 0, -1)'=__ -shaped piece
    Call initialise_piece(53, 6, 6, 0, 0, RGB(70, 110, 155), -1, 0, 0, 0, 1, 0, 2, 0, 0, 1, 1, -1)'reverse =__ -shaped piece
    Call initialise_piece(54, 6, 8, 0, 0, RGB(0, 100, 0), -1, 0, 0, 0, 1, 0, 2, 0, 2, 1, 0, -1)'#-shaped piece
    Call initialise_piece(55, 6, 8, 0, 0, RGB(0, 0, 100), -1, 0, 0, 0, 1, 0, 2, 0, 0, 1, 2, -1)'reverse #-shaped piece
    Call initialise_piece(56, 6, 7, 0, 0, RGB(68, 100, 0), -1, 0, 0, 0, 1, 0, 2, 0, 2, 1, 1, -1)'@-shaped piece
    Call initialise_piece(57, 6, 7, 0, 0, RGB(68, 0, 100), -1, 0, 0, 0, 1, 0, 2, 0, 1, 1, 2, -1)'reverse @-shaped piece
    Call initialise_piece(58, 6, 8, 0, 0, RGB(75, 205, 52), -2, 1, -1, 1, 0, 1, 1, 1, 1, 0, 1, -1)'reverse L-shaped piece
    Call initialise_piece(59, 6, 8, 0, 0, RGB(68, 52, 210), -2, -1, -1, -1, 0, -1, 1, -1, 1, 0, 1, 1)'L-shaped piece
    Call initialise_piece(60, 6, 8, 0, 0, RGB(255, 175, 52), -2, 1, -1, 1, 0, 1, 0, 0, 1, 0, 1, -1)'reverse W+1-shaped piece
    Call initialise_piece(61, 6, 8, 0, 0, RGB(255, 52, 175), -2, -1, -1, -1, 0, -1, 0, 0, 1, 0, 1, 1)'W+1-shaped piece
    Call initialise_piece(62, 6, 10, 0, 0, RGB(210, 210, 255), -2, -1, -1, -1, 0, -1, 0, 0, 1, 0, 2, 0)'lightning-shaped piece
    Call initialise_piece(63, 6, 7, 0, 0, RGB(155, 52, 175), -1, -1, 0, -1, 1, -1, 1, 0, 1, 1, 0, -2)'L+1-shaped piece
    Call initialise_piece(64, 6, 7, 0, 0, RGB(140, 190, 255), -1, -1, 0, -1, 1, -1, 1, 0, 1, 1, 2, 0)'reverse L+1-shaped piece
    Call initialise_piece(65, 6, 8, 0, 0, RGB(155, 30, 0), -1, -1, 0, -1, 1, -1, 1, 0, 1, 1, -1, -2)'L+1-shaped piece
    Call initialise_piece(66, 6, 6, 0, 0, RGB(115, 220, 0), -1, -1, 0, -1, 1, -1, 1, 0, 1, 1, 2, -1)'different L+1-shaped piece
    Call initialise_piece(67, 6, 6, 0, 0, RGB(180, 60, 78), -1, -1, 0, -1, 1, -1, 1, 0, 0, 0, 2, -1)'-==- -shaped piece
    Call initialise_piece(68, 6, 7, 0, 0, RGB(72, 160, 78), -2, 0, -1, 0, -1, 1, 0, 0, 0, -1, 1, -1)'silly(W+1)-shaped piece
    Call initialise_piece(69, 6, 7, 0, 0, RGB(80, 170, 28), -1, -1, 0, -1, 0, 0, 1, 0, 2, 0, 1, 1)'reverse silly(W+1)-shaped piece
    Call initialise_piece(70, 6, 7, 0, 0, RGB(10, 120, 8), -1, 0, 0, 0, 0, 1, 0, 2, 1, -1, 1, 0)'nasty(T+1)-shaped piece
    Call initialise_piece(71, 6, 7, 0, 0, RGB(10, 135, 28), -1, 0, 0, 0, 0, 1, 0, 2, -1, -1, 1, 0)'reverse nasty(T+1)-shaped piece
    Call initialise_piece(72, 6, 10, 0, 0, RGB(255, 210, 255), -2, 1, -1, 1, 0, 1, 0, 0, 1, 0, 2, 0)'reverse lightning-shaped piece
    Call initialise_piece(73, 6, 7, 0, 0, RGB(105, 15, 75), -1, -1, -1, 0, 0, -1, 1, 0, 1, -1, 2, -1)'F-shaped piece
    Call initialise_piece(74, 6, 8, 0, 0, RGB(195, 10, 75), -2, -1, -1, -1, 0, -1, 1, -1, -1, 0, 1, 0)'reverse F-shaped piece
    Call initialise_piece(75, 6, 8, 0, 0, RGB(180, 240, 234), -1, 2, -1, 1, 0, 1, 0, 0, 1, 0, 1, -1)'reverse zigzag-shaped piece
    Call initialise_piece(76, 6, 6, 0, 0, RGB(165, 120, 10), -1, -1, 0, -1, 1, -1, 1, 0, 1, 1, 1, -2)'different L+1-shaped piece
    Call initialise_piece(77, 6, 7, 0, 0, RGB(90, 78, 90), -2, -1, -1, -1, 0, -1, -1, 0, 0, 0, 1, 0)'reverse trapezium-shaped piece
    Call initialise_piece(78, 6, 7, 0, 0, RGB(45, 75, 80), -1, 0, 0, 0, 1, 0, 0, -1, 1, -1, 2, -1)'reverse trapezium-shaped piece
    'one piece
    Call initialise_piece(79, 1, 1, 0, 0, RGB(230, 230, 230), 0, 0, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99)'1
    'Bis piece
    Call initialise_piece(80, 2, 1, 0, 0, RGB(230, 230, 255), 0, 0, 1, 0, 99, 99, 99, 99, 99, 99, 99, 99)'2
    'Tris pieces
    Call initialise_piece(81, 3, 2, 0, 0, RGB(255, 220, 235), -1, 0, 0, 0, 1, 0, 99, 99, 99, 99, 99, 99)'3 in a line
    Call initialise_piece(82, 3, 2, 0, 0, RGB(230, 255, 230), 0, 1, 0, 0, 1, 0, 99, 99, 99, 99, 99, 99)'3 corner
End Sub

