Option Explicit

Function Choose_FontName$ (width_of_text%)
Select Case Int(width_of_text / 10)
    Case 0, 1, 2, 3, 4, 5, 6
	Choose_FontName = "Small Fonts"
    Case 7, 8, 9
	Choose_FontName = "Arial"
    Case Else
	Choose_FontName = "Times New Roman"
End Select
End Function

Function Choose_FontSize% (width_of_text%)
Select Case Int(width_of_text / 10)
     Case 0, 1, 2, 3
	 Choose_FontSize% = 2.25 'Small Fonts
     Case 4
	 Choose_FontSize% = 3    'Small Fonts
     Case 5, 6
	 Choose_FontSize% = 3.75 'Small Fonts
     Case 7, 8
	 Choose_FontSize% = 6    'Arial
     Case 9
	 Choose_FontSize% = 8.25 'Arial
     Case 10
	 Choose_FontSize% = 8.25 'Times New Roman
     Case 11, 12
	 Choose_FontSize% = 9.75 'Times New Roman
     Case 13
	 Choose_FontSize% = 11   'Times New Roman
     Case 14
	 Choose_FontSize% = 12   'Times New Roman
     Case Else
	 Choose_FontSize% = 13   'Times New Roman
End Select
End Function

Function Choose_Score_Panel_Height% (width_of_text)
Select Case Int(width_of_text / 10)
     Case 0, 1, 2, 3
	 Choose_Score_Panel_Height = 45
     Case 4
	 Choose_Score_Panel_Height = 70
     Case 5, 6
	 Choose_Score_Panel_Height = 100
     Case 7, 8
	 Choose_Score_Panel_Height = 120
     Case 9
	 Choose_Score_Panel_Height = 150
     Case 10
	 Choose_Score_Panel_Height = 155
     Case 11, 12
	 Choose_Score_Panel_Height = 190
     Case 13
	 Choose_Score_Panel_Height = 225
     Case 14
	 Choose_Score_Panel_Height = 250
     Case Else
	 Choose_Score_Panel_Height = 265
End Select
End Function

Sub Draw_Cell (G As Griid, colour&, i%, j%)
    Area_pt.CurrentX = G.origin.x + G.cellsize.x * (i - 1)
    Area_pt.CurrentY = G.origin.y + G.cellsize.y * (j - 1)
    If ColourOn Then
	Area_pt.Line -Step(G.cellsize.x, G.cellsize.y), colour&, BF
    ElseIf colour > 0 Then Area_pt.Line -Step(G.cellsize.x, G.cellsize.y), &HFFFFFF, BF
    Else Area_pt.Line -Step(G.cellsize.x, G.cellsize.y), 0, BF
    End If
    Area_pt.CurrentX = G.origin.x + G.cellsize.x * (i - 1)
    Area_pt.CurrentY = G.origin.y + G.cellsize.y * (j - 1)
    Area_pt.Line -Step(G.cellsize.x, G.cellsize.y), QBColor(7), B
End Sub

Sub Draw_Grid (G As Griid)
Dim i%, j%  'Draws the Grid -  G
 For i = 1 To G.size
    For j = 1 To G.size
	Call Draw_Cell(G, G.cells(i, j), i, j)
    Next j
 Next i
End Sub

Sub Draw_Highlight (G As Griid, i%, j%)
    Area_pt.CurrentX = G.origin.x + G.cellsize.x * (i - 1)
    Area_pt.CurrentY = G.origin.y + G.cellsize.y * (j - 1)
    Area_pt.Line -Step(G.cellsize.x, G.cellsize.y), QBColor(4), B
    Area_pt.CurrentX = G.origin.x + G.cellsize.x * (i - 1) + G.cellsize.x / 200
    Area_pt.CurrentY = G.origin.y + G.cellsize.y * (j - 1) + G.cellsize.y / 200
    Area_pt.Line -Step(G.cellsize.x - G.cellsize.x / 100, G.cellsize.y - G.cellsize.y / 100), QBColor(4), B
End Sub

Sub Draw_next_piece (pieceno%)
Dim Dummycursor As coords
Dim Dummypiece As piece
    If pieceno > 0 Then
	Dummypiece = The_Pieces(pieceno)
	If (ColourOn = 0) Then Dummypiece.colour = &HFFFFFF
	Area_pt.Line (Next_Piece_Grid.origin.x, Next_Piece_Grid.origin.y)-Step(Next_Piece_Grid.cellsize.x * Next_Piece_Grid.size, Next_Piece_Grid.cellsize.y * Next_Piece_Grid.size), Area_pt.BackColor, BF'clear Background
	If Area_pt.NextPiece.Checked Then
	    Call Set_Cursor(Next_Piece_Grid, Dummycursor)
	    Call Draw_Piece(Next_Piece_Grid, Dummypiece, Dummycursor)
	End If
    End If
End Sub

Sub Draw_Piece (G As Griid, P As piece, Cursor As coords)
Dim c%
    'Draws the relevant piece,
    For c = 1 To P.size
	Call Draw_Cell(G, P.colour, Cursor.x + P.cells(c).x, Cursor.y + P.cells(c).y)
	If Area_pt.HighlightPieceMenu.Checked Then Call Draw_Highlight(G, Cursor.x + P.cells(c).x, Cursor.y + P.cells(c).y)
    Next c
End Sub

Sub Flash_Column (G As Griid, col_number%)
Dim i%, j%
For i = 1 To No_times_to_flash
    For j = 1 To G.size
	Call Draw_Cell(G, G.cells(col_number, j), col_number, j)
	Call Draw_Cell(G, 0, col_number, j)
    Next j
Next i
mybeep
End Sub

Sub Flash_Row (G As Griid, row_number%)
Dim i%, j%
For j = 1 To No_times_to_flash
    For i = 1 To G.size
	Call Draw_Cell(G, G.cells(i, row_number), i, row_number)
	Call Draw_Cell(G, 0, i, row_number)
    Next i
Next j
mybeep
End Sub

Sub refresh_screen ()
    Call Draw_Grid(The_Grid)
    Call Draw_next_piece(Next_Piece_No)
End Sub

