Option Explicit

Sub gameover ()
    Call suspend
    Call New_High_Score(The_Score, No_Pieces, No_Columns, No_Rows)
    Call Change_Playing_State(False)
End Sub

Sub Get_piece (P As piece, pieceno%, P_Set%) 'Allocates a new piece
    P = The_Pieces(pieceno%)
    Select Case P_Set
	Case 4
	    pieceno = Int(Rnd * 7) + 1
	Case 5
	    pieceno = Int(Rnd * 15) + 8
	Case Else
	    pieceno = Int(Rnd * Max_No_pieces) + 1
    End Select
    If (pieceno = 24 And The_Grid.size = 5) Then pieceno = Int(Rnd * 7) + 1
    Call Draw_next_piece(pieceno%)
    No_Time_Units_To_Drop = Time_Const
End Sub

Function max% (a%, b%)
    If a% > b% Then max = a Else max = b
End Function

Function min% (a%, b%)
    If a% < b% Then min = a Else min = b
End Function

Sub Move_Down (G As Griid, P As piece, cursor As coords)
Dim c%, downmost_y%
    'Moves the piece down, if it goes down
    downmost_y = P.cells(1).y
    For c = 2 To P.size
	downmost_y = min(downmost_y, P.cells(c).y)
    Next c
    If (downmost_y + cursor.y > 1) Then cursor.y = cursor.y - 1
End Sub

Sub Move_Left (G As Griid, P As piece, cursor As coords)
Dim c%, leftmost_x%
    'Moves the piece left, if it goes left
    leftmost_x = P.cells(1).x
    For c = 2 To P.size
	leftmost_x = min(leftmost_x, P.cells(c).x)
    Next c
    If (leftmost_x + cursor.x > 1) Then cursor.x = cursor.x - 1
End Sub

Sub Move_Right (G As Griid, P As piece, cursor As coords)
Dim c%, rightmost_x%
    'Moves the piece right, if it goes right
    rightmost_x = P.cells(1).x
    For c = 2 To P.size
	rightmost_x = max(rightmost_x, P.cells(c).x)
    Next c
    If (rightmost_x + cursor.x < G.size) Then cursor.x = cursor.x + 1
End Sub

Sub Move_Up (G As Griid, P As piece, cursor As coords)
Dim c%, upmost_y%
    'Moves the piece up, if it goes up
    upmost_y = P.cells(1).y
    For c = 2 To P.size
	upmost_y = max(upmost_y, P.cells(c).y)
    Next c
    If (upmost_y + cursor.y < G.size) Then cursor.y = cursor.y + 1
    End Sub

Sub mybeep ()
If Area_pt.SoundMenu.Checked Then Beep
End Sub

Sub newgame (G As Griid)
Dim i%, j%
    The_Score = 0
    Area_pt.ScoreField.Caption = "Score: " + CStr(The_Score)
    No_Pieces = 0
    Area_pt.NoPiecesField.Caption = "# Pieces: " + CStr(No_Pieces)
    No_Rows = 0
    Area_pt.NoRowsField.Caption = "# Rows: " + CStr(No_Rows)
    No_Columns = 0
    Area_pt.NoColumnsField.Caption = "# Columns: " + CStr(No_Columns)
    Call Get_piece(The_Piece, Next_Piece_No, G.Piece_Set)' NB This repeat line is intentional and necessary
    Call Set_Cursor(The_Grid, The_Cursor)
    For i = 1 To G.size
	For j = 1 To G.size
	    G.cells(i, j) = 0
	Next j%
    Next i%
    Call Change_Playing_State(True)
End Sub

Sub Pause (G As Griid)
    Call suspend    'Stop the timers
    Was_paused = True
    Call Set_Pause_Checks(Was_paused)
    'Curtain down
    '@@
    '@@
End Sub

Sub Flip_piece (G As Griid, P As piece, cursor As coords)
Dim c%, flip_legal%
Dim temp As coords
Dim newcoords()  As coords
ReDim newcoords(P.size)
    flip_legal = True
    For c = 1 To P.size
	temp.x = P.cells(c).y * -1
	temp.y = P.cells(c).x * -1
	If min(temp.x + cursor.x, temp.y + cursor.y) < 1 Or max(temp.x + cursor.x, temp.y + cursor.y) > G.size Then flip_legal = False
	newcoords(c) = temp
    Next c
    If flip_legal Then
	For c = 1 To P.size
	    P.cells(c) = newcoords(c)
	Next c
    Else
	mybeep
    End If
End Sub

Sub Remove_Lines (G As Griid)
Dim i%, j%, nocols%, norows%, bonus%
Dim finished_cols() As Integer, finished_rows() As Integer
ReDim finished_cols(G.size), finished_rows(G.size)
    nocols = 0
    norows = 0
    For i = 1 To G.size 'See if any columns are completed
	finished_cols(i) = 1
	For j = 1 To G.size
	    If (G.cells(i, j) = 0) Then finished_cols(i) = 0
	Next j
    Next i
    For j = 1 To G.size 'See if any rows are completed
	finished_rows(j) = 1
	For i = 1 To G.size
	    If (G.cells(i, j) = 0) Then finished_rows(j) = 0
	Next i
    Next j
    For i = 1 To G.size 'Remove any completed columns
	If finished_cols(i) Then
	    nocols = nocols + 1
	    Call Flash_Column(G, i)
	    For j = 1 To G.size 'Erase column
		G.cells(i, j) = 0
	    Next j
	End If
    Next i
    For j = 1 To G.size 'Remove any completed rows
	If finished_rows(j) Then
	    norows = norows + 1
	    Call Flash_Row(G, j)
	    For i = 1 To G.size 'Erase row
		G.cells(i, j) = 0
	    Next i
	End If
    Next j
    bonus = nocols + norows
    If (nocols > 0 And norows > 0) Then bonus = 2 * bonus
    The_Score = The_Score + bonus * Score_per_line
    No_Columns = No_Columns + nocols
    No_Rows = No_Rows + norows
    Area_pt.ScoreField.Caption = "Score: " + CStr(The_Score)
    Area_pt.NoRowsField.Caption = "# Rows: " + CStr(No_Rows)
    Area_pt.NoColumnsField.Caption = "# Columns: " + CStr(No_Columns)
End Sub

Sub Rotate_piece (direction%, G As Griid, P As piece, cursor As coords)
Dim c%, rotate_legal%
Dim temp As coords
Dim newcoords()  As coords
ReDim newcoords(P.size)
    rotate_legal = True
    For c = 1 To P.size
	temp.x = P.cells(c).y * direction
	temp.y = P.cells(c).x * direction * -1
	If min(temp.x + cursor.x, temp.y + cursor.y) < 1 Or max(temp.x + cursor.x, temp.y + cursor.y) > G.size Then rotate_legal = False
	newcoords(c) = temp
    Next c
    If rotate_legal Then
	For c = 1 To P.size
	    P.cells(c) = newcoords(c)
	Next c
    Else
	mybeep
    End If
End Sub

Sub Change_Playing_State (playing%)
    Area_pt.SizeMenu.Enabled = Not (playing)
    Area_pt.PiecesMenu.Enabled = Not (playing)
    Area_pt.Refresh_Screen.Enabled = playing
    Area_pt.GameMenuPause.Enabled = playing
    Area_pt.GameMenuPause.Visible = playing
    Area_pt.SkillMenuPractice.Enabled = Not (playing)
    Area_pt.SkillMenuBeginner.Enabled = Not (playing)
    Area_pt.SkillMenuIntermediate.Enabled = Not (playing)
    Area_pt.SkillMenuExpert.Enabled = Not (playing)
    Area_pt.CustomMenu.Enabled = Not (playing)
    Area_pt.GameMenuUnpause.Visible = Not (playing)
    Area_pt.GamemenuQuitgame.Enabled = playing
End Sub

Sub Drop_Piece (G As Griid, P As piece, cursor As coords)
Dim c%, legaldrop%
  If Area_pt.GamemenuQuitgame.Enabled Then
    legaldrop = True
    Call Draw_Piece(G, P, cursor)
    For c = 1 To P.size
	If (G.cells(P.cells(c).x + cursor.x, P.cells(c).y + cursor.y) > 0) Then legaldrop = False
    Next c
    If legaldrop Then
	The_Score = The_Score + P.value + min(No_Columns, No_Rows)
	No_Pieces = No_Pieces + 1
	Area_pt.NoPiecesField.Caption = "# Pieces: " + CStr(No_Pieces)
	For c = 1 To P.size
	    G.cells(P.cells(c).x + cursor.x, P.cells(c).y + cursor.y) = P.colour
	Next c
	Call Remove_Lines(G)
	Call Get_piece(P, Next_Piece_No, G.Piece_Set)
	Call Draw_next_piece(Next_Piece_No)
	Call Set_Cursor(G, cursor)
    Else
	Call gameover
    End If
  End If
End Sub

Sub Set_Cursor (G As Griid, cursor As coords)
    cursor.x = Int((G.size + 1) / 2)
    cursor.y = Int((G.size + 1) / 2)
End Sub

Sub Set_Difficulty (G As Griid, Difficulty%)
   The_Difficulty = Difficulty
   Select Case Difficulty
       Case 1, 2, 3
	    G.size = Difficulty + 4
	    G.Piece_Set = Difficulty + 3
       Case Else
	    G.size = Gsize
	    G.Piece_Set = Piece_Set
   End Select
   Call Set_Difficulty_String(Timed, G.Piece_Set, Gsize, Difficulty)
   Call Set_Grid_Size(G)
   Call Set_Difficulty_Checks(The_Difficulty)
End Sub

Sub Set_Difficulty_Checks (diff%)
    Area_pt.SkillMenuBeginner.Checked = (diff = 1)
    Area_pt.SkillMenuIntermediate.Checked = (diff = 2)
    Area_pt.SkillMenuExpert.Checked = (diff = 3)
    Area_pt.CustomMenu.Checked = (diff = 4)
End Sub

Sub Set_Difficulty_String (isTimed%, pieces%, size%, Difficulty%)
   If (Difficulty < 4) Then
	Difficulty_String = Difficulty_Name(The_Difficulty)
   ElseIf (size = pieces + 1) Then
	Difficulty_String = Difficulty_Name(size - 4)
   Else
	Difficulty_String = "Custom (" + CStr(size) + "x" + CStr(size) + ") (" + Pieces_Name(pieces - 3) + ")"
   End If
   If isTimed = 0 Then Difficulty_String = Difficulty_String + " (Untimed)"
End Sub

Sub Set_Grid_Size (G As Griid)
Dim ScreenWidth%, ScreenHeight%, no_characters_to_print%
Dim Score_Panel_height%, fs%, fn$
    no_characters_to_print = 62 'approx
    Area_pt.Cls
    'WIDTH
    ScreenWidth% = max(0, (Area_pt.ScaleWidth - 2 * OtherBorderWidths))
    Score_Panel_height% = Choose_Score_Panel_Height(ScreenWidth / no_characters_to_print)
    ScreenHeight% = max(0, (Area_pt.ScaleHeight - OtherBorderWidths - TopBorderWidth - Score_Panel_height))
    'Set Grid size
    G.origin.x = OtherBorderWidths
    G.origin.y = TopBorderWidth + Score_Panel_height
    G.cellsize.x = ScreenWidth% / G.size
    G.cellsize.y = ScreenHeight% / G.size
    ' Set Form labels
    Area_pt.ScoreField.Left = OtherBorderWidths
    Area_pt.NoRowsField.Left = OtherBorderWidths + .2 * ScreenWidth
    Area_pt.NoColumnsField.Left = OtherBorderWidths + .4 * ScreenWidth
    Area_pt.NoPiecesField.Left = OtherBorderWidths + .6 * ScreenWidth
    fn$ = Choose_FontName(ScreenWidth / no_characters_to_print)
    Area_pt.ScoreField.FontName = fn
    Area_pt.NoRowsField.FontName = fn
    Area_pt.NoColumnsField.FontName = fn
    Area_pt.NoPiecesField.FontName = fn
    fs% = Choose_FontSize(ScreenWidth / no_characters_to_print)
    Area_pt.ScoreField.FontSize = fs
    Area_pt.NoRowsField.FontSize = fs
    Area_pt.NoColumnsField.FontSize = fs
    Area_pt.NoPiecesField.FontSize = fs
    ' set Next Piece Grid
    Next_Piece_Grid.origin.x = OtherBorderWidths + .8 * ScreenWidth
    Next_Piece_Grid.origin.y = 0'TopBorderWidth
    Next_Piece_Grid.size = G.Piece_Set
    Next_Piece_Grid.cellsize.x = .2 * ScreenWidth / Next_Piece_Grid.size
    Next_Piece_Grid.cellsize.y = (Score_Panel_height + TopBorderWidth) / Next_Piece_Grid.size
    Call refresh_screen
End Sub

Sub Set_Pause_Checks (Paused_or_not%)
    Area_pt.GameMenuUnpause.Visible = Paused_or_not
    Area_pt.GameMenuUnpause.Enabled = Paused_or_not
    Area_pt.GameMenuPause.Visible = Not (Paused_or_not)
    Area_pt.GameMenuPause.Enabled = Not (Paused_or_not)
End Sub

Sub suspend ()
    'Stop the timers...
    Area_pt.Refresh_Screen.Enabled = False
    Area_pt.Draw_Piece.Enabled = False
End Sub

Sub Unpause (G As Griid)
    Was_paused = False
    Call Set_Pause_Checks(Was_paused)
    Area_pt.Refresh_Screen.Enabled = True
End Sub

